module Ddr
  module HasIntermediateFile
    extend ActiveSupport::Concern

    included do
      attribute :intermediate_file, Ddr::File.optional
    end

    def intermediate_type
      intermediate_file&.media_type
    end

    # This method is used in dul-hydra 'ComponentsController'
    def intermediate_extension
      if filename = intermediate_file&.original_filename
        ::File.extname(filename)
      end
    end

    def intermediate_path
      intermediate_file&.file&.disk_path
    end

  end
end
